/* Boyer-Moore@ɂ镶T */

#include <stdio.h>
#include <string.h>
#include <limits.h>

/*--- Boyer-Moore@ɂ镶T ---*/
int bm_match(const char txt[], const char pat[])
{
	int pt;							/* txtȂJ[\ */
	int pp;							/* patȂJ[\ */
	int txt_len = strlen(txt);		/* txt̕ */
	int pat_len = strlen(pat);		/* pat̕ */
	int skip[UCHAR_MAX + 1];		/* XLbve[u */

	for (pt = 0; pt <= UCHAR_MAX; pt++)		/* XLbve[u̍쐬 */
		skip[pt] = pat_len;
	for (pt = 0; pt < pat_len - 1; pt++)
		skip[pat[pt]] = pat_len - pt - 1;
	/* pt == pat_len - 1 ł */
	while (pt < txt_len) {
		pp = pat_len - 1;					/* pat̍Ō̕ɒ */

		while (txt[pt] == pat[pp]) {
			if (pp == 0)
				return pt;
			pp--;
			pt--;
		}
		pt += (skip[txt[pt]] > pat_len - pp) ? skip[txt[pt]] : pat_len - pp;
	}

	return -1;
}

int main(void)
{
	int  idx;
	char s1[256];		/* eLXg */
	char s2[256];		/* p^[ */

	puts("Boyer-Moore@");

	printf("eLXgF");
	scanf("%s", s1);

	printf("p^[F");
	scanf("%s", s2);

	idx = bm_match(s1, s2);	/* s1當s2Boyer-Moore@ŒT */

	if (idx == -1)
		puts("eLXgɃp^[݂͑܂B");
	else
		printf("%dڂɃ}b`܂B\n", idx + 1);

	return 0;
}
